//
// Simple fluid system for visualiztion purposes
//
// Author: Simon Green
// Email: sdkfeedback@nvidia.com
//
// Copyright (c) NVIDIA Corporation. All rights reserved.
////////////////////////////////////////////////////////////////////////////////

#include "VolumeBuffer.h"
#include "Program.h"

// class to represent a simple 3D simulation
class FluidSystem {
public:
    FluidSystem(CGcontext context, int width, int height, int depth);
    ~FluidSystem();

    void reset();
    void step(float timestep);
    void splat();

    VolumeBuffer *getStateBuffer() { return m_state[m_current]; }

private:
    float frand();

    int m_width, m_height, m_depth;

    VolumeBuffer *m_state[2];
    VolumeBuffer *m_prevState;
    int m_current;

    CGcontext m_cg_context;
    Program *m_clear_prog, *m_copy_prog, *m_splat_prog;
    Program *m_step_prog;
};
